ompi/mca/ptl/sm/ptl_sm.h File Reference.TH "ompi/mca/ptl/sm/ptl_sm.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/ptl/sm/ptl_sm.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include <stdlib.h>\fP
.br
\fC#include <sys/types.h>\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'class/ompi_bitmap.h'\fP
.br
\fC#include 'class/ompi_fifo.h'\fP
.br
\fC#include 'opal/event/event.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'mca/ptl/ptl.h'\fP
.br
\fC#include 'mca/mpool/mpool.h'\fP
.br
\fC#include 'mca/common/sm/common_sm_mmap.h'\fP
.br
\fC#include 'mca/ptl/sm/ptl_sm_peer.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBSM_CONNECTED\fP   1"
.br
.ti -1c
.RI "#define \fBSM_CONNECTED_SAME_BASE_ADDR\fP   2"
.br
.ti -1c
.RI "#define \fBSM_CONNECTED_DIFFERENT_BASE_ADDR\fP   3"
.br
.ti -1c
.RI "#define \fBMCA_PTL_SM_SIGNAL_PEER\fP(peer)"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef mca_ptl_sm_module_resource_t \fBmca_ptl_sm_module_resource_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_ptl_sm_component_t\fP \fBmca_ptl_sm_component_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_ptl_sm_t\fP \fBmca_ptl_sm_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_ptl_sm_component_open\fP (void)"
.br
.RI "\fIRegister shared memory module parameters with the MCA framework. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_component_close\fP (void)"
.br
.RI "\fIAny final cleanup before being unloaded. \fP"
.ti -1c
.RI "\fBmca_ptl_base_module_t\fP ** \fBmca_ptl_sm_component_init\fP (int *num_ptls, bool enable_progress_threads, bool enable_mpi_threads)"
.br
.RI "\fISM module initialization. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_component_control\fP (int param, void *value, size_t size)"
.br
.RI "\fIshared memory component control. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_component_progress\fP (mca_ptl_tstamp_t tstamp)"
.br
.RI "\fIshared memory component progress. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_finalize\fP (struct \fBmca_ptl_base_module_t\fP *ptl)"
.br
.RI "\fICleanup any resources held by the PTL. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_add_procs\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers, struct ompi_bitmap_t *reachability)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_add_procs_same_base_addr\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers, ompi_bitmap_t *reachability)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_del_procs\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_request_alloc\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.br
.RI "\fIPML->PTL Allocate a send request from the PTL modules free list. \fP"
.ti -1c
.RI "void \fBmca_ptl_sm_request_return\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.br
.RI "\fIPML->PTL Return a send request to the PTL modules free list. \fP"
.ti -1c
.RI "void \fBmca_ptl_sm_matched_same_base_addr\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *frag)"
.br
.RI "\fIPML->PTL Notification that a receive fragment has been matched. \fP"
.ti -1c
.RI "void \fBmca_ptl_sm_matched\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *frag)"
.br
.RI "\fIPML->PTL Notification that a receive fragment has been matched. \fP"
.ti -1c
.RI "void \fBmca_ptl_sm_matched_common_base_addr\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *frag)"
.br
.RI "\fIPML->PTL Notification that a receive fragment has been matched. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_send\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *, size_t offset, size_t size, int flags)"
.br
.RI "\fIPML->PTL Initiate a send of the specified size. \fP"
.ti -1c
.RI "int \fBmca_ptl_sm_send_continue\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *, size_t offset, size_t size, int flags)"
.br
.RI "\fIPML->PTL send second and subsequent fragments. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "mca_ptl_sm_module_resource_t \fBmca_ptl_sm_module_resource\fP"
.br
.ti -1c
.RI "\fBmca_ptl_sm_component_t\fP \fBmca_ptl_sm_component\fP"
.br
.ti -1c
.RI "\fBmca_ptl_sm_t\fP \fBmca_ptl_sm\fP [2]"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Function Documentation"
.PP 
.SS "int mca_ptl_sm_add_procs (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_ptl_base_peer_t\fP ** peers, struct ompi_bitmap_t * reachability)"
.PP
PML->PTL notification of change in the process list. 
.PP
PML->PTL Notification that a receive fragment has been matched. Called for message that is send from process with the virtual address of the shared memory segment being different than that of the receiver.
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) 
.br
\fIproc\fP (IN) 
.br
\fIpeer\fP (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "int mca_ptl_sm_add_procs_same_base_addr (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_ptl_base_peer_t\fP ** peers, ompi_bitmap_t * reachability)"
.PP
PML->PTL notification of change in the process list. 
.PP
PML->PTL Notification that a receive fragment has been matched. Called for message that is send from process with the virtual address of the shared memory segment being the same as that of the receiver.
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) 
.br
\fIproc\fP (IN) 
.br
\fIpeer\fP (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "\fBmca_ptl_base_module_t\fP** mca_ptl_sm_component_init (int * num_ptls, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
SM module initialization. 
.PP
\fBParameters:\fP
.RS 4
\fInum_ptls\fP (OUT) Number of PTLs returned in PTL array. 
.br
\fIenable_progress_threads\fP (IN) Flag indicating whether PTL is allowed to have progress threads 
.br
\fIenable_mpi_threads\fP (IN) Flag indicating whether PTL must support multilple simultaneous invocations from different threads 
.RE
.PP

.SS "int mca_ptl_sm_del_procs (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_ptl_base_peer_t\fP ** peers)"
.PP
PML->PTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIproc\fP (IN) Peer process 
.br
\fIpeer\fP (IN) Peer addressing information. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful 
.RE
.PP

.SS "int mca_ptl_sm_finalize (struct \fBmca_ptl_base_module_t\fP * ptl)"
.PP
Cleanup any resources held by the PTL. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP PTL instance. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "void mca_ptl_sm_matched (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_recv_frag_t\fP * frag)"
.PP
PML->PTL Notification that a receive fragment has been matched. 
.PP
Called for message that is send from process with the virtual address of the shared memory segment being different than that of the receiver.
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrecv_frag\fP (IN) Receive fragment 
.RE
.PP

.SS "void mca_ptl_sm_matched_common_base_addr (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_recv_frag_t\fP * frag)"
.PP
PML->PTL Notification that a receive fragment has been matched. 
.PP
Called for message that is send from process with the virtual address of the shared memory segment being the same as that of the receiver.
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrecv_frag\fP (IN) Receive fragment 
.RE
.PP

.SS "void mca_ptl_sm_matched_same_base_addr (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_recv_frag_t\fP * frag)"
.PP
PML->PTL Notification that a receive fragment has been matched. 
.PP
Called for message that is send from process with the virtual address of the shared memory segment being the same as that of the receiver.
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrecv_frag\fP (IN) Receive fragment 
.RE
.PP

.SS "int mca_ptl_sm_request_alloc (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.PP
PML->PTL Allocate a send request from the PTL modules free list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (OUT) Pointer to allocated request. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if allocation was successful. 
.RE
.PP

.SS "void mca_ptl_sm_request_return (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.PP
PML->PTL Return a send request to the PTL modules free list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (IN) Pointer to allocated request. 
.RE
.PP

.SS "int mca_ptl_sm_send (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_peer_t\fP * ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *, size_t offset, size_t size, int flags)"
.PP
PML->PTL Initiate a send of the specified size. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIptl_base_peer\fP (IN) PTL peer addressing 
.br
\fIsend_request\fP (IN/OUT) Send request (allocated by PML via mca_ptl_base_request_alloc_fn_t) 
.br
\fIsize\fP (IN) Number of bytes PML is requesting PTL to deliver 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the PTL was able to queue one or more fragments 
.RE
.PP

.SS "int mca_ptl_sm_send_continue (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_peer_t\fP * ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *, size_t offset, size_t size, int flags)"
.PP
PML->PTL send second and subsequent fragments. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIptl_base_peer\fP (IN) PTL peer addressing 
.br
\fIsend_request\fP (IN/OUT) Send request (allocated by PML via mca_ptl_base_request_alloc_fn_t) 
.br
\fIsize\fP (IN) Number of bytes PML is requesting PTL to deliver 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the PTL was able to queue one or more fragments 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
